unit sunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TsetDateForm = class(TForm)
    sdate: TDateTimePicker;
    stime: TDateTimePicker;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    tic: TTimer;
    procedure sdateChange(Sender: TObject);
    procedure stimeChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ticTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
    procedure SetSys;
  public
    { Public declarations }
    procedure Execute;
  end;

var
  setDateForm: TsetDateForm;

implementation

{$R *.DFM}
 procedure TsetDateForm.Execute;
 begin
  stime.Time:=Time;
  sdate.Date:=Date;
  button1.Enabled:=false;
  button2.Enabled:=false;
  tic.Enabled:=true;
  ShowModal;
 end;

 procedure TsetDateForm.SetSys;
  var
   stame:TSystemTime;
 begin
  with stame do begin
   DecodeDate(sdate.Date,wYear,wMonth,wDay);
   wDayOfWeek:=DayOfWeek(sdate.Date)-1;
   DecodeTime(stime.Time,wHour,wMinute,wSecond,wMilliseconds);
   wMilliseconds:=0;
  end;
  SetLocalTime(stame);
  tic.Enabled:=true;
 end;
procedure TsetDateForm.sdateChange(Sender: TObject);
begin
 button1.Enabled:=true;
 button2.Enabled:=true;
end;

procedure TsetDateForm.stimeChange(Sender: TObject);
begin
 button1.Enabled:=true;
 button2.Enabled:=true;
 tic.Enabled:=false;
end;

procedure TsetDateForm.Button1Click(Sender: TObject);
begin
 SetSys;
 button1.Enabled:=false;
 button2.Enabled:=false;
 close;
end;

procedure TsetDateForm.Button2Click(Sender: TObject);
begin
 setsys;
 button1.Enabled:=false;
 button2.Enabled:=false;
end;

procedure TsetDateForm.Button3Click(Sender: TObject);
begin
 button1.Enabled:=false;
 button2.Enabled:=false;
 close;
end;

 procedure TsetDateForm.ticTimer(Sender: TObject);
 begin
  stime.Time:=Time;
 end;

procedure TsetDateForm.FormShow(Sender: TObject);
begin
 tic.Enabled:=true;
end;

procedure TsetDateForm.FormHide(Sender: TObject);
begin
 tic.Enabled:=false;
end;

end.
